*******************************************************************************
*  FILE:         Winapi.h
*
*  WRITTEN BY:   Borland Samples Group
*
*  DATE:         7/15/93
*
*  UPDATED:      6/94
*
*  REVISION:     $Revision:   2.20  $
*
*  VERSION:      dBASE FOR WINDOWS 5.0
*
*  DESCRIPTION:  This file contains Windows API function declarations
*                for calls to the Windows API from dBASE for Windows.
*
*  USAGE:        (in a file)
*                #include <Winapi.h>
*
*******************************************************************************

#define NULL        0
#define FALSE       0
#define TRUE        1
#define CBYTE       CWORD    && because a minimum of a CWORD is read anyway
#define RGB(r,g,b)  (r + g*256 + b*65536)

*** Constants for pixel screen dimensions

#define PIXELROWS     GetSystemMetrics(1)    && Screen Rows in pixels
#define PIXELCOLS     GetSystemMetrics(0)    && Screen Columns in pixels


*** External Function Declarations

***************** Drawing and Windowing functions

extern  CLOGICAL  AnyPopup(CVOID) USER.EXE
extern  CLOGICAL  Arc ( CHANDLE,CINT,CINT,CINT,CINT,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CINT      ArrangeIconicWindows(CHANDLE) USER.EXE
extern  CLOGICAL  BitBlt ( CHANDLE,CINT,CINT,CINT,CINT,CHANDLE,CINT,CINT,CLONG )  GDI.EXE
extern  CWORD     CascadeChildWindows(CWORD,CWORD) USER.EXE
extern  CLOGICAL  Chord ( CHANDLE,CINT,CINT,CINT,CINT,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CVOID     CloseWindow( CHANDLE ) USER.EXE
extern  CINT      CombineRgn ( CHANDLE,CHANDLE,CHANDLE,CINT )  GDI.EXE
extern  CHANDLE   CopyCursor ( CHANDLE,CHANDLE )  USER.EXE
extern  CHANDLE   CreateCompatibleDC ( CHANDLE ) GDI.EXE
extern  CHANDLE   CreateCursor ( CHANDLE,CINT,CINT,CINT,CINT,CSTRING,CSTRING) USER.EXE
extern  CHANDLE   CreateDc ( CSTRING,CSTRING,CSTRING,CPTR) GDI.EXE
extern  CHANDLE   CreateEllipticRgn ( CINT,CINT,CINT,CINT )  GDI.EXE
extern  CHANDLE   CreateHatchBrush ( CINT,CLONG )  GDI.EXE
extern  CHANDLE   CreatePatternBrush ( CHANDLE )  GDI.EXE
extern  CHANDLE   CreatePen ( CINT,CINT,CLONG)  GDI.EXE
extern  CHANDLE   CreateRectRgn ( CINT,CINT,CINT,CINT )  GDI.EXE
extern  CHANDLE   CreateRoundRectRgn ( CINT,CINT,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CHANDLE   CreateSolidBrush ( CLONG )  GDI.EXE
extern  CHANDLE   CreateWindow( CSTRING,CSTRING,CDOUBLE,CINT,CINT,CINT,CINT,;
                  CHANDLE,CHANDLE,CHANDLE,CLONG ) USER.EXE
extern  CLOGICAL  DeleteDc ( CHANDLE )  GDI.EXE
extern  CLOGICAL  DeleteObject ( CHANDLE )  GDI.EXE
extern  CLOGICAL  DestroyCursor ( CHANDLE )  USER.EXE
extern  CLOGICAL  DestroyIcon ( CHANDLE )  USER.EXE
extern  CLOGICAL  DestroyWindow( CHANDLE ) USER.EXE
extern  CLOGICAL  DrawIcon ( CHANDLE,CINT,CINT,CHANDLE )  USER.EXE
extern  CHANDLE   Ellipse ( CHANDLE,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CLOGICAL  EqualRgn ( CHANDLE,CHANDLE )  GDI.EXE
extern  CINT      Escape ( CHANDLE,CINT,CINT,CSTRING,CPTR )  GDI.EXE
extern  CINT      ExcludeClipRect ( CHANDLE,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CINT      ExcludeUpdateRgn ( CHANDLE,CHANDLE )  USER.EXE
extern  CLOGICAL  ExtFloodFill ( CHANDLE,CINT,CINT,CLONG,CINT )  GDI.EXE
extern  CLOGICAL  FillRgn ( CHANDLE,CHANDLE,CHANDLE )  GDI.EXE
extern  CHANDLE   FindWindow( CSTRING,CSTRING ) USER.EXE
extern  CLOGICAL  FlashWindow ( CHANDLE,CLOGICAL )  USER.EXE
extern  CLOGICAL  FloodFill ( CHANDLE,CINT,CINT,CLONG )  GDI.EXE
extern  CLOGICAL  FrameRgn ( CHANDLE,CHANDLE,CHANDLE,CINT,CINT )  GDI.EXE
extern  CHANDLE   GetActiveWindow (CVOID) USER.EXE
extern  CDOUBLE   GetBitmapDIMENSION ( CHANDLE )  GDI.EXE
extern  CLONG     GetBkColor ( CHANDLE )  GDI.EXE
extern  CINT      GetBkMode ( CHANDLE )  GDI.EXE
extern  CLONG     GetBrushORG ( CHANDLE )  GDI.EXE
extern  CLOGICAL  GetCharWidth ( CHANDLE,CINT,CINT,CSTRING )  GDI.EXE
extern  CVOID     GetClientRect ( CHANDLE, CPTR ) USER.EXE
extern  CDOUBLE   GetCurrentPosition ( CHANDLE )  GDI.EXE
extern  CHANDLE   GetCursor ( CVOID )  USER.EXE
extern  CVOID     GetCursorPos ( CPTR )  USER.EXE
extern  CHANDLE   GetDc ( CHANDLE )  USER.EXE
extern  CLONG     GetDcOrg ( CHANDLE )  GDI.EXE
extern  CHANDLE   GetDeskTopWindow ( CVOID )  USER.EXE
extern  CLONG     GetDialogBaseUnits( CVOID ) USER.EXE
extern  CHANDLE   GetFocus ( CVOID )  USER.EXE
extern  CHANDLE   GetNextWindow ( CHANDLE,CINT )  USER.EXE
extern  CHANDLE   GetParent ( CHANDLE )  USER.EXE
extern  CLONG     GetPixel ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CINT      GetPolyFillMode ( CHANDLE )  GDI.EXE
extern  CHANDLE   GetStockObject ( CINT )  GDI.EXE
extern  CINT      GetStretchBltMode ( CHANDLE )  GDI.EXE
extern  CLONG     GetSysColor ( CINT )  USER.EXE
extern  CHANDLE   GetSysModalWindow ( CVOID )  USER.EXE
extern  CINT      GetSystemPaletteEntries ( CHANDLE,CINT,CINT,CPTR )  GDI.EXE
extern  CINT      GetSystemPaletteUse ( CHANDLE )  GDI.EXE
extern  CLONG     GetTabbedTextExtent ( CHANDLE,CSTRING,CINT,CINT,CPTR )  USER.EXE
extern  CINT      GetTextAlign ( CHANDLE )  GDI.EXE
extern  CINT      GetTextCharacterExtra ( CHANDLE )  GDI.EXE
extern  CLONG     GetTextColor ( CHANDLE )  GDI.EXE
extern  CLONG     GetTextExtent ( CHANDLE,CSTRING,CINT )  GDI.EXE
extern  CLOGICAL  GetTextExtentPoint ( CHANDLE,CSTRING,CINT,CPTR )  GDI.EXE
extern  CINT      GetTextFace ( CHANDLE,CINT,CSTRING )  GDI.EXE
extern  CLOGICAL  GetTextMetrics ( CHANDLE,CPTR )  GDI.EXE
extern  CHANDLE   GetTopWindow ( CHANDLE )  USER.EXE
extern  CINT      GetUpdateRgn ( CHANDLE,CHANDLE,CLOGICAL )  USER.EXE
extern  CHANDLE   GetWindow ( CHANDLE,CINT )  USER.EXE
extern  CHANDLE   GetWindowDc ( CHANDLE )  USER.EXE
extern  CLONG     GetWindowExt ( CHANDLE )  GDI.EXE
extern  CLONG     GetWindowOrg ( CHANDLE )  GDI.EXE
extern  CVOID     GetWindowRect ( CHANDLE, CPTR ) USER.EXE
extern  CHANDLE   GetWindowTask( CHANDLE ) USER.EXE
extern  CINT      GetWindowText ( CHANDLE,CSTRING,CINT ) USER.EXE
extern  CINT      IntersectClipRect ( CHANDLE,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CVOID     InvalidateRgn ( CHANDLE,CHANDLE,CLOGICAL )  USER.EXE
extern  CLOGICAL  InvertRgn ( CHANDLE,CHANDLE )  GDI.EXE
extern  CLOGICAL  IsChild ( CHANDLE,CHANDLE )  USER.EXE
extern  CLOGICAL  IsIconIC ( CHANDLE )  USER.EXE
extern  CLOGICAL  IsWindowVisible( CHANDLE ) USER.EXE
extern  CLOGICAL  LineTo ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CHANDLE   LoadBitmap ( CHANDLE,CSTRING )  USER.EXE
extern  CHANDLE   LoadCursor ( CSTRING,CHANDLE )  USER.EXE
extern  CHANDLE   LoadIcon ( CHANDLE,CSTRING )  USER.EXE
extern  CVOID     MessageBeep ( CINT )  USER.EXE
extern  CINT      MessageBox ( CHANDLE,CSTRING,CSTRING,CINT )  USER.EXE
extern  CLONG     MoveTo ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CHANDLE   OffsetClipRgn ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CINT      OffsetRgn ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CLONG     OffSetWindowOrg ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CLOGICAL  OpenIcon ( CHANDLE )  USER.EXE
extern  CLOGICAL  PaintRgn ( CHANDLE,CHANDLE )  GDI.EXE
extern  CLOGICAL  PatBlt ( CHANDLE,CINT,CINT,CINT,CINT,CLONG )  GDI.EXE
extern  CLOGICAL  Pie ( CHANDLE,CINT,CINT,CINT,CINT,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CLOGICAL  PtInRegion ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CLOGICAL  PtVisible ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CLOGICAL  Rectangle ( CHANDLE,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CVOID     ReleaseCapture ( CVOID )  USER.EXE
extern  CINT      ReleaseDc ( CHANDLE,CHANDLE )  USER.EXE
extern  CLOGICAL  RestoreDc( CHANDLE,CINT ) GDI.EXE
extern  CLOGICAL  RoundRect ( CHANDLE,CINT,CINT,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CINT      SaveDc( CHANDLE ) GDI.EXE
extern  CINT      SelectClipRgn ( CHANDLE,CHANDLE )  GDI.EXE
extern  CHANDLE   SelectObject ( CHANDLE,CHANDLE )  GDI.EXE
extern  CLONG     SetBitmapDimension ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CLONG     SetBkColor ( CHANDLE,CLONG )  GDI.EXE
extern  CINT      SetBkMode ( CHANDLE,CINT )  GDI.EXE
extern  CLONG     SetBrushOrg ( CHANDLE,CINT,CINT )  GDI.EXE
extern  CHANDLE   SetCapture ( CHANDLE )  USER.EXE
extern  CHANDLE   SetCursor ( CHANDLE )  USER.EXE
extern  CVOID     SetCursorPos ( CINT,CINT )  USER.EXE
extern  CVOID     SetDoubleClickTime ( CINT )  USER.EXE
extern  CHANDLE   SetParent ( CHANDLE,CHANDLE )  USER.EXE
extern  CLONG     SetPixel ( CHANDLE,CINT,CINT,CLONG )  GDI.EXE
extern  CINT      SetPolyFillMode ( CHANDLE,CINT )  GDI.EXE
extern  CVOID     SetRectRgn ( CHANDLE,CINT,CINT,CINT,CINT )  GDI.EXE
extern  CINT      SetStretchBltMode ( CHANDLE,CINT )  GDI.EXE
extern  CHANDLE   SetSysModalWindow ( CHANDLE )  USER.EXE
extern  CLONG     SetWindowOrg( CHANDLE,CINT,CINT ) GDI.EXE
extern  CVOID     SetWindowText( CHANDLE,CSTRING ) USER.EXE
extern  CINT      ShowCursor ( CLOGICAL )  USER.EXE
extern  CLOGICAL  ShowWindow( CHANDLE,CINT ) USER.EXE
extern  CLOGICAL  StretchBlt ( CHANDLE,CINT,CINT,CINT,CINT,CHANDLE,CINT,CINT,CINT,CINT,CLONG )  GDI.EXE
extern  CVOID     UpdateWindow ( CHANDLE )  USER.EXE
extern  CVOID     ValidateRgn ( CHANDLE,CHANDLE )  USER.EXE


*** Constant Graphing and Windowing Function Parameters
*******************************************************************************


********************** BitBlt() Raster Operation Types ************************

#define BLACKNESS           htoi("00000042")  &&* Turns all output black
#define DSTINVERT           htoi("00550009")  &&* Inverts destination
                                              &&  bitmap
#define MERGECOPY           htoi("00C000CA")  &&* Combines pattern and source
                                              &&  bitmap using Boolean AND
#define MERGEPAINT          htoi("00BB0226")  &&* Combines inverted source
                                              &&  with destination using
                                              &&  Boolean OR
#define NOTSRCCOPY          htoi("00330008")  &&* Copies inverted source
                                              &&  to destination
#define NOTSRCERASE         htoi("001100A6")  &&* Inverts result of combining
                                              &&  destination and source
                                              &&  bitmaps using Boolean OR
#define PATCOPY             htoi("00F00021")  &&* Copies pattern to
                                              &&  destination bitmap
#define PATINVERT           htoi("005A0049")  &&* Combines destination
                                              &&  bitmap with pattern using
                                              &&  Boolean XOR
#define PATPAINT            htoi("00FB0A09")  &&* Combines inverted source
                                              &&  with pattern using Boolean
                                              &&  OR.  Combines result of this
                                              &&  operation with destination
                                              &&  using Boolean OR.
#define SRCAND              htoi("008800C6")  &&* Combines pixels of
                                              &&  destination and source
                                              &&  bitmaps using Boolean AND
#define SRCCOPY             htoi("00CC0020")  &&* Copies source bitmap to
                                              &&  destination bitmap
#define SRCERASE            htoi("00440328")  &&* Inverts destination bitmap
                                              &&  and combines result with
                                              &&  source bitmap using Boolean
                                              &&  AND
#define SRCINVERT           htoi("00660046")  &&* Combines pixels of
                                              &&  destination and source
                                              &&  bitmaps using Boolean XOR
#define SRCPAINT            htoi("00EE0086")  &&* Combines pixels of
                                              &&  destination and source
                                              &&  bitmaps using Boolean OR
#define WHITENESS           htoi("00FF0062")  &&* Turns all output white


************************* CombineRgn() command values *************************

#define RGN_AND             1
#define RGN_OR              2
#define RGN_XOR             3
#define RGN_DIFF            4
#define RGN_COPY            5

************************* CreateHatchBrush() hatch styles *********************

#define HS_BDIAGONAL        3
#define HS_CROSS            4
#define HS_DIAGCROSS        5
#define HS_FDIAGONAL        2
#define HS_HORIZONTAL       0
#define HS_VERTICAL         1


****************************** CreatePen() pen styles *************************

#define PS_DASH             1
#define PS_DASHDOT          3
#define PS_DASHDOTDOT       4
#define PS_DOT              2
#define PS_INSIDEFRAME      6
#define PS_NULL             5
#define PS_SOLID            0



************************* CreateWindow() window styles ************************
*** These can be combined using Dbasewin's boolean functions

*** Clipping styles

#define WS_CLIPSIBLINGS      htoi("04000000")
#define WS_CLIPCHILDREN      htoi("02000000")

#define WS_CHILD             htoi("40000000")
#define WS_OVERLAPPED        htoi("00000000")
#define WS_POPUP             htoi("80000000")


*** Generic window states
#define WS_DISABLED          htoi("08000000")
#define WS_VISIBLE           htoi("10000000")

*** Main window states
#define WS_MAXIMIZE          htoi("01000000")
#define WS_MINIMIZE          htoi("20000000")

*** Main window styles

#define WS_BORDER            htoi("00800000")
#define WS_CAPTION           htoi("00C00000")    && bitor(WS_BORDER,WS_DLGFRAME)
#define WS_DLGFRAME          htoi("00400000")
#define WS_HSCROLL           htoi("00100000")
#define WS_MAXIMIZEBOX       htoi("00010000")
#define WS_MINIMIZEBOX       htoi("00020000")
#define WS_SYSMENU           htoi("00080000")
#define WS_THICKFRAME        htoi("00040000")
#define WS_VSCROLL           htoi("00200000")

*** Control window styles

#define WS_GROUP             htoi("00020000")
#define WS_TABSTOP           htoi("00010000")

*** Common Window Styles

#define WS_CHILDWINDOW       WS_CHILD
#define WS_OVERLAPPEDWINDOW  bitor(WS_OVERLAPPED,WS_CAPTION,WS_SYSMENU,;
                                      WS_THICKFRAME,WS_MINIMIZEBOX,;
                                      WS_MAXIMIZEBOX)
#define WS_POPUPWINDOW       bitor(WS_POPUP,WS_BORDER,WS_SYSMENU)

*** Extended Window Styles

#define WS_EX_ACCEPTFILES    htoi("00000010")
#define WS_EX_DLGMODALFRAME  htoi("00000001")
#define WS_EX_NOPARENTNOTIFY htoi("00000004")
#define WS_EX_TOPMOST        htoi("00000008")
#define WS_EX_TRANSPARENT    htoi("00000020")

*** Obsolete style names

#define WS_ICONIC            WS_MINIMIZE
#define WS_SIZEBOX           WS_THICKFRAME
#define WS_TILED             WS_OVERLAPPED
#define WS_TILEDWINDOW       WS_OVERLAPPEDWINDOW







************************** DrawText() drawing flags ***************************

#define DT_CHARSTREAM        4
#define DT_DISPFILE          6
#define DT_METAFILE          5
#define DT_PLOTTER           0
#define DT_RASCAMERA         3
#define DT_RASDISPLAY        1
#define DT_RASPRINTER        2

************************* Escape() error codes ********************************

#define SP_ERROR            -1
#define SP_APPABORT         -2
#define SP_USERABORT        -3
#define SP_OUTOFDISK        -4
#define SP_OUTOFMEMORY      -5

******************** GetClientRect() specifications ***************************

#define GCR_WIDTH            5       && Client area width
#define GCR_HEIGHT           7       && Client area height


******************** GetDcEx() device context creation options ****************

#define DCX_CACHE            htoi("00000002")
#define DCX_CLIPCHILDREN     htoi("00000008")
#define DCX_CLIPSIBLINGS     htoi("00000010")
#define DCX_EXCLUDERGN       htoi("00000040")
#define DCX_INTERSECTRGN     htoi("00000080")
#define DCX_LOCKWINDOWUPDATE htoi("00000400")
#define DCX_PARENTCLIP       htoi("00000020")
#define DCX_USESTYLE         htoi("00010000")
#define DCX_WINDOW           htoi("00000001")

************************ GetWindowRect() coordinate constants *****************

#define GWR_LEFT             1       && Window left in pixels
#define GWR_TOP              3       && Window top in pixels
#define GWR_RIGHT            5       && Window right in pixels
#define GWR_BOT              7       && Window bottom in pixels

************************ GetStockObject() stock object types ******************

#define BLACK_BRUSH          4
#define DKGRAY_BRUSH         3
#define GRAY_BRUSH           2
#define HOLLOW_BRUSH         5
#define LTGRAY_BRUSH         1
#define NULL_BRUSH           5
#define WHITE_BRUSH          0


************************** ExtFloodFill() style flags *************************

#define FLOODFILLBORDER      0
#define FLOODFILLSURFACE     1


************************** GetBkMode() background modes ***********************

#define TRANSPARENT          1
#define OPAQUE               2


*********************** GetSysColor() display elements ************************

#define COLOR_ACTIVEBORDER        10
#define COLOR_ACTIVECAPTION        2
#define COLOR_APPWORKSPACE        12
#define COLOR_BACKGROUND           1
#define COLOR_BTNFACE             15
#define COLOR_BTNSHADOW           16
#define COLOR_BTNTEXT             18
#define COLOR_CAPTIONTEXT          9
#define COLOR_GRAYTEXT            17
#define COLOR_HIGHLIGHT           13
#define COLOR_HIGHLIGHTTEXT       14
#define COLOR_INACTIVEBORDER      11
#define COLOR_INACTIVECAPTION      3
#define COLOR_MENU                 4


#define COLOR_MENUTEXT             7
#define COLOR_SCROLLBAR            0
#define COLOR_WINDOW               5
#define COLOR_WINDOWFRAME          6
#define COLOR_WINDOWTEXT           8
#define COLOR_INACTIVECAPTIONTEXT 19
#define COLOR_BTNHIGHLIGHT        20


*************************** GetWindow() relationship flags ********************

#define GW_CHILD            5
#define GW_HWNDFIRST        0
#define GW_HWNDLAST         1
#define GW_HWNDNEXT         2
#define GW_HWNDPREV         3
#define GW_OWNER            4



******************** LoadBitmap() predefined Windows bitmaps ******************

#define OBM_CLOSE           32754
#define OBM_COMBO           32738
#define OBM_DNARROW         32752
#define OBM_DNARROWD        32742
#define OBM_LFARROW         32750
#define OBM_LFARROWD        32740
#define OBM_MNARROW         32739
#define OBM_REDUCE          32749
#define OBM_REDUCED         32746
#define OBM_RESTORE         32747
#define OBM_RESTORED        32744
#define OBM_RGARROW         32751
#define OBM_RGARROWD        32741
#define OBM_UPARROW         32753
#define OBM_UPARROWD        32743
#define OBM_ZOOM            32748
#define OBM_ZOOMD           32745
#define OBM_DNARROWI        32736
#define OBM_LFARROWI        32734
#define OBM_RGARROWI        32735
#define OBM_UPARROWI        32737

#define OBM_BTNCORNERS      32758
#define OBM_BTSIZE          32761
#define OBM_CHECK           32760
#define OBM_CHECKBOXES      32759
#define OBM_OLD_CLOSE       32767
#define OBM_OLD_DNARROW     32764
#define OBM_OLD_LFARROW     32762
#define OBM_OLD_REDUCE      32757
#define OBM_OLD_RESTORE     32755
#define OBM_OLD_RGARROW     32763
#define OBM_OLD_UPARROW     32765
#define OBM_OLD_ZOOM        32756
#define OBM_SIZE            32766

************************* LoadCursor() predefined Windows cursors *************

#define IDC_ARROW           32512
#define IDC_CROSS           32515
#define IDC_IBEAM           32513
#define IDC_ICON            32641
#define IDC_SIZE            32640
#define IDC_SIZENESW        32643
#define IDC_SIZENS          32645
#define IDC_SIZENWSE        32642
#define IDC_SIZEWE          32644
#define IDC_UPARROW         32516
#define IDC_WAIT            32514

************************* LoadIcon() predefined Windows icons *****************

#define IDI_APPLICATION     32512
#define IDI_ASTERISK        32516
#define IDI_EXCLAMATION     32515
#define IDI_HAND            32513
#define IDI_QUESTION        32514

************************ MessageBox() Dialog Types ****************************

#define MB_ABORTRETRYIGNORE htoi("0002")    &&* Message box contains Abort,
                                            &&  Retry, Ignore pushbuttons
#define MB_APPLMODAL        htoi("0000")    &&* User must respond to the message
                                            &&  box before continuing work in
                                            &&  the parent window.
#define MB_DEFBUTTON1       htoi("0000")    &&* The first button is the default
#define MB_DEFBUTTON2       htoi("0100")    &&* The second button is the default
#define MB_DEFBUTTON3       htoi("0200")    &&* The third button is the default
#define MB_ICONASTERISK     htoi("0040")    &&* Same as MB_ICONINFORMATION
#define MB_ICONEXCLAMATION  htoi("0030")    &&* Exclamation point icon appears
#define MB_ICONHAND         htoi("0010")    &&* Same as MB_ICONSTOP
#define MB_ICONINFORMATION  MB_ICONASTERISK &&* A lower case "I" icon apperas
#define MB_ICONQUESTION     htoi("0020")    &&* A question mark icon appears
#define MB_ICONSTOP         MB_ICONHAND     &&* A stop-sign icon appears
#define MB_OK               htoi("0000")    &&* OK pushbutton
#define MB_OKCANCEL         htoi("0001")    &&* OK and Cancel pushbuttons
#define MB_RETRYCANCEL      htoi("0005")    &&* Retry and Cancel pushbuttons
#define MB_SYSTEMMODAL      htoi("1000")    &&* All applications are suspended
                                            &&  until the user responds to the
                                            &&  message box
#define MB_TASKMODAL        htoi("2000")    &&* Same as APPL_MODAL except that
                                            &&  all the top-level windows
                                            &&  belonging to the current task
                                            &&  are disabled if the parent
                                            &&  window is not specified
#define MB_YESNO            htoi("0004")    &&* Yes and No pushbuttons
#define MB_YESNOCANCEL      htoi("0003")    &&* Yes, No, Cancel pushbuttons



******************* MessageBox() Standard dialog button IDs ******************
#define IDOK                1
#define IDCANCEL            2
#define IDABORT             3
#define IDRETRY             4
#define IDIGNORE            5
#define IDYES               6
#define IDNO                7


**************************** StretchBlt() Modes *******************************

#define STRETCH_ANDSCANS        1
#define STRETCH_ORSCANS         2
#define STRETCH_DELETESCANS     3




***************************** Clipboard Functions *****************************


extern  CLOGICAL  ChangeClipboardChain ( CHANDLE,CHANDLE )  USER.EXE
extern  CLOGICAL  CloseClipboard ( CVOID )  USER.EXE
extern  CINT      CountClipboardFormats ( CVOID )  USER.EXE
extern  CLOGICAL  EmptyClipboard ( CVOID )  USER.EXE
extern  CINT      EnumClipboardFormats ( CINT )  USER.EXE
extern  CHANDLE   GetClipboardData ( CINT )  USER.EXE
extern  CINT      GetClipboardFormatName ( CINT,CSTRING,CINT )  USER.EXE
extern  CHANDLE   GetClipboardOwner ( CVOID )  USER.EXE
extern  CHANDLE   GetClipboardViewer ( CVOID )  USER.EXE
extern  CHANDLE   GetOpenClipboardWindow ( CVOID )  USER.EXE
extern  CINT      GetPriorityClipboardFormat ( CPTR,CINT )  USER.EXE
extern  CLOGICAL  IsClipboardFormatAvailable ( CINT )  USER.EXE
extern  CLOGICAL  OpenClipboard ( CHANDLE )  USER.EXE
extern  CINT      RegisterClipboardFormat ( CSTRING )  USER.EXE
extern  CHANDLE   SetClipboardData ( CINT,CHANDLE )  USER.EXE
extern  CHANDLE   SetClipboardViewer ( CHANDLE )  USER.EXE


**************** SetClipboardData() system defined clipboard formats **********

#define CF_BITMAP            2
#define CF_DIB               8
#define CF_DIF               5
#define CF_DSPBITMAP        htoi("0082")
#define CF_DSPMETAFILEPICT  htoi("0083")
#define CF_DSPTEXT          htoi("0081")
#define CF_METAFILEPICT      3
#define CF_OEMTEXT           7
#define CF_OWNERDISPLAY     htoi("0080")
#define CF_PALETTE           9
#define CF_PENDATA          10
#define CF_RIFF             11
#define CF_SYLK              4
#define CF_TEXT              1
#define CF_TIFF              6
#define CF_WAVE             12

*** "Private" formats don't get GlobalFree()'d
#define CF_PRIVATEFIRST     htoi("0200")
#define CF_PRIVATELAST      htoi("02FF")

*** "GDIOBJ" formats do get DeleteObject()'d
#define CF_GDIOBJFIRST      htoi("0300")
#define CF_GDIOBJLAST       htoi("03FF")









************************** Miscellaneous Functions *****************************s

extern  CINT      AccessResource ( CHANDLE,CHANDLE )  KRNL386.EXE
extern  CWORD     AddAtom( CSTRING ) krnl386.exe
extern  CVOID     CreateCaret( CHANDLE,CHANDLE,CINT,CINT ) USER.EXE

extern  CWORD     DeleteAtom( CWORD ) krnl386.exe
extern  CVOID     DestroyCaret( CVOID ) USER.EXE
extern  CLOGICAL  ExitWindows ( CLONG,CINT )  USER.EXE
extern  CLOGICAL  ExitWindowsExec ( CSTRING,CSTRING )  USER.EXE
extern  CVOID     FatalAppExit ( CINT,CSTRING )  KRNL386.EXE
extern  CWORD     FindAtom(CSTRING) krnl386.exe
extern  CHANDLE   FindResource ( CHANDLE,CSTRING,CSTRING )  KRNL386.EXE
extern  CVOID     FreeLibrary ( CHANDLE )  KRNL386.EXE
extern  CLOGICAL  FreeModule( CHANDLE ) krnl386.exe
extern  CLOGICAL  FreeResource ( CHANDLE )  KRNL386.EXE
extern  CINT      GetCaretBlinkTime( CVOID ) USER.EXE
extern  CINT      GetClassName ( CHANDLE,CSTRING,CINT )  USER.EXE
extern  CHANDLE   GetCurrentTask ( CVOID )  KRNL386.EXE
extern  CLONG     GetCurrentTime ( CVOID )  USER.EXE
extern  CINT      GetDeviceCAPS ( CHANDLE,CINT )  GDI.EXE
extern  CINT      GetDriveType( CINT ) krnl386.exe
extern  CSTRING   GetDosEnvironment ( CVOID )  KRNL386.EXE
extern  CINT      GetDoubleClickTime ( CVOID )  USER.EXE
extern  CLONG     GetFreeSpace ( CINT )  KRNL386.EXE
extern  CINT      GetFreeSystemResourceS ( CINT )  USER.EXE
extern  CLOGICAL  GetInputState( CLOGICAL ) User.exe
extern  CINT      GetKeyState( CINT ) USER.EXE
extern  CINT      GetKbCodePage( CVOID ) Keyboard.drv
extern  CINT      GetModuleFileName( CHANDLE,CSTRING,CINT ) krnl386.exe
extern  CHANDLE   GetModuleHandle( CSTRING ) krnl386.exe
extern  CINT      GetModuleUsage( CHANDLE) krnl386.exe
extern  CINT      GetNumTaskS ( CVOID )  KRNL386.EXE
extern  CINT      GetPrivateProfileInt ( CSTRING,CSTRING,CINT,CSTRING )  KRNL386.EXE
extern  CINT      GetPrivateProfileString ( CSTRING,CSTRING,CSTRING,CSTRING,CINT,CSTRING )  KRNL386.EXE
extern  CINT      GetProfileInt ( CSTRING,CSTRING,CINT )  KRNL386.EXE
extern  CINT      GetProfileString ( CSTRING,CSTRING,CSTRING,CSTRING,CINT )  KRNL386.EXE
extern  CINT      GetSystemDirectory ( CSTRING,CINT )  KRNL386.EXE
extern  CINT      GetSystemMetrics ( CINT )  USER.EXE
extern  CBYTE     GetTempDrive ( CWORD )  KRNL386.EXE
extern  CLONG     GetTickCount ( CVOID )  USER.EXE
extern  CLONG     GetTimerResolution ( CVOID )  USER.EXE
extern  CLONG     GetVersion ( CVOID )  KRNL386.EXE
extern  CINT      GetWindowsDirectory ( CSTRING,CINT )  KRNL386.EXE
extern  CLONG     GetWinFlags ( CVOID )  KRNL386.EXE
extern  CVOID     HideCaret( CHANDLE ) USER.EXE
extern  CLOGICAL  IsTask ( CHANDLE )  KRNL386.EXE
extern  CLOGICAL  IsWindow ( CHANDLE )  USER.EXE
extern  CLOGICAL  IsWindowEnabled ( CHANDLE )  USER.EXE
extern  CLOGICAL  IsWindowVisible ( CHANDLE )  USER.EXE
extern  CLOGICAL  IsZoomed ( CHANDLE )  USER.EXE
extern  CHANDLE   LoadLibrary ( CSTRING ) KRNL386.EXE
extern  CHANDLE   LoadModule ( CSTRING,CPTR )  KRNL386.EXE
extern  CHANDLE   LoadResource ( CHANDLE,CHANDLE )  KRNL386.EXE
extern  CINT      LoadString( CHANDLE,CINT,CSTRING,CINT ) USER.EXE
extern  CLOGICAL  PostAppMessage ( CHANDLE,CINT,CWORD,CLONG )  USER.EXE
extern  CLOGICAL  PeekMessage ( CPTR,CHANDLE,CINT,CINT,CINT )  USER.EXE
extern  CVOID     ReplyMessage ( CLONG )  USER.EXE
extern  CVOID     SetCaretBlinkTime( CINT ) USER.EXE
extern  CVOID     SetCaretPos( CINT,CINT ) USER.EXE
extern  CLONG     SendMessage ( CHANDLE,CINT,CWORD,CLONG )  USER.EXE
extern  CINT      SetHandleCount ( CINT )  KRNL386.EXE
extern  CVOID     ShowCaret( CHANDLE ) USER.EXE
extern  CLONG     SizeOFResource ( CHANDLE,CHANDLE )  KRNL386.EXE
extern  CWORD     SndPlaySound( CPTR,CWORD ) mmsystem.dll
extern  CLOGICAL  SwapMouseButton ( CLOGICAL )  USER.EXE
extern  CLOGICAL  SystemParametersInfo ( CINT,CINT,CPTR,CINT )  USER.EXE
extern  CINT      WinExec ( CSTRING,CINT )  KRNL386.EXE
extern  CLOGICAL  WinHelp ( CHANDLE,CSTRING,CINT,CLONG )  USER.EXE
extern  CLOGICAL  WritePrivateProfileString ( CSTRING,CSTRING,CSTRING,CSTRING )  KRNL386.EXE
extern  CLOGICAL  WriteProfileString ( CSTRING,CSTRING,CSTRING )  KRNL386.EXE



*** Constant Miscellaneous Function Parameters
*******************************************************************************

**************************** ExitWindows() error codes ************************

#define EW_RESTARTWINDOWS   htoi("42")
#define EW_REBOOTSYSTEM     htoi("43")



************************** FindResource() resource types **********************

#define RT_ACCELERATOR      9
#define RT_BITMAP           2
#define RT_CURSOR           1
#define RT_DIALOG           5
#define RT_FONT             8
#define RT_FONTDIR          7
#define RT_GROUP_CURSOR     12
#define RT_GROUP_ICON       14
#define RT_ICON             3
#define RT_MENU             4
#define RT_RCDATA           10
#define RT_STRING           6



*********************** GetDeviceCaps() device information options ************

#define ASPECTX       40
#define ASPECTXY      44
#define ASPECTY       42
#define BITSPIXEL     12
#define CLIPCAPS      36
#define COLORRES     108
#define CURVECAPS     28
#define DRIVERVERSION 0
#define HORZRES       8
#define HORZSIZE      4
#define LINECAPS      30
#define LOGPIXELSX    88
#define LOGPIXELSY    90
#define NUMBRUSHES    16
#define NUMCOLORS     24
#define NUMFONTS      22
#define NUMMARKERS    20
#define NUMPENS       18
#define NUMRESERVED  106
#define PDEVICESIZE   26
#define PLANES        14
#define POLYGONALCAPS 32
#define RASTERCAPS    38
#define SIZEPALETTE  104
#define TECHNOLOGY    2
#define TEXTCAPS      34
#define VERTRES       10
#define VERTSIZE      6

************************* GetFreeSystemResources() resource types ***************

#define GFSR_SYSTEMRESOURCES   0
#define GFSR_GDIRESOURCES      1
#define GFSR_USERRESOURCES     2

***************************** GetKeyboardType types *****************************

#define GKT_TYPE               0       && Main kbd type
#define GKT_SUBTYPE            1       && Mfgr. subtype
#define GKT_NUMFUNCTION        2       && Number of FKeys

**************************** GetSystemMetrics() codes ***************************

#define SM_CXSCREEN          0
#define SM_CYSCREEN          1
#define SM_CXVSCROLL         2
#define SM_CYHSCROLL         3
#define SM_CYCAPTION         4
#define SM_CXBORDER          5
#define SM_CYBORDER          6
#define SM_CXDLGFRAME        7
#define SM_CYDLGFRAME        8
#define SM_CYVTHUMB          9
#define SM_CXHTHUMB          10
#define SM_CXICON            11
#define SM_CYICON            12
#define SM_CXCURSOR          13
#define SM_CYCURSOR          14
#define SM_CYMENU            15
#define SM_CXFULLSCREEN      16
#define SM_CYFULLSCREEN      17
#define SM_CYKANJIWINDOW     18
#define SM_MOUSEPRESENT      19
#define SM_CYVSCROLL         20
#define SM_CXHSCROLL         21
#define SM_DEBUG             22
#define SM_SWAPBUTTON        23
#define SM_RESERVED1         24
#define SM_RESERVED2         25
#define SM_RESERVED3         26
#define SM_RESERVED4         27
#define SM_CXMIN             28
#define SM_CYMIN             29
#define SM_CXSIZE            30
#define SM_CYSIZE            31
#define SM_CXFRAME           32
#define SM_CYFRAME           33
#define SM_CXMINTRACK        34
#define SM_CYMINTRACK        35

#define SM_CXDOUBLECLK       36
#define SM_CYDOUBLECLK       37
#define SM_CXICONSPACING     38
#define SM_CYICONSPACING     39
#define SM_MENUDROPALIGNMENT 40
#define SM_PENWINDOWS        41
#define SM_DBCSENABLED       42

#define SM_CMETRICS          43


******************* GetWinFlags() system/memory configurations ****************

#define WF_887          htoi("0400")
#define WF_CPU086       htoi("0040")
#define WF_CPU186       htoi("0080")
#define WF_CPU286       htoi("0002")
#define WF_CPU386       htoi("0004")
#define WF_CPU486       htoi("0008")
#define WF_ENHANCED     htoi("0020")
#define WF_LARGEFRAME   htoi("0100")
#define WF_PAGING       htoi("0800")
#define WF_PMODE        htoi("0001")
#define WF_SMALLFRAME   htoi("0200")
#define WF_STANDARD     htoi("0010")
#define WF_WIN286       htoi("0010")
#define WF_WIN386       htoi("0020")
#define WF_WLO          htoi("8000")



********************** ShellExecute() window display options ******************

#define SW_HIDE             0
#define SW_MAXIMIZE         3
#define SW_MINIMIZE         6
#define SW_NORMAL           1
#define SW_RESTORE          9
#define SW_SHOW             5
#define SW_SHOWMAXIMIZED    3
#define SW_SHOWMINIMIZED    2
#define SW_SHOWMINNOACTIVE  7
#define SW_SHOWNA           8
#define SW_SHOWNOACTIVATE   4
#define SW_SHOWNORMAL       1

***************** SystemParametersInfo() parameters to query/set **************

#define SPI_GETBEEP                 1
#define SPI_GETBORDER               5
#define SPI_GETFASTTASKSWITCH       35
#define SPI_GETGRIDGRANULARITY      18
#define SPI_GETICONTITLELOGFONT     31
#define SPI_GETICONTITLEWRAP        25
#define SPI_GETKEYBOARDDELAY        22
#define SPI_GETKEYBOARDSPEED        10
#define SPI_GETMENUDROPALIGNMENT    27
#define SPI_GETMOUSE                3
#define SPI_GETSCREENSAVEACTIVE     16
#define SPI_GETSCREENSAVETIMEOUT    14
#define SPI_ICONHORIZONTALSPACING   13
#define SPI_ICONVERTICALSPACING     24
#define SPI_LANGDRIVER              12
#define SPI_SETBEEP                 2
#define SPI_SETBORDER               6
#define SPI_SETDESKPATTERN          21
#define SPI_SETDESKWALLPAPER        20
#define SPI_SETDOUBLECLICKTIME      32
#define SPI_SETDOUBLECLKHEIGHT      30
#define SPI_SETDOUBLECLKWIDTH       29
#define SPI_SETFASTTASKSWITCH       36
#define SPI_SETGRIDGRANULARITY      19
#define SPI_SETICONTITLELOGFONT     34
#define SPI_SETICONTITLEWRAP        26
#define SPI_SETKEYBOARDDELAY        23
#define SPI_SETKEYBOARDSPEED        11
#define SPI_SETMENUDROPALIGNMENT    28
#define SPI_SETMOUSE                4
#define SPI_SETMOUSEBUTTONSWAP      33
#define SPI_SETSCREENSAVEACTIVE     17
#define SPI_SETSCREENSAVETIMEOUT    15

********************** WinHelp() requested help types *************************

#define HELP_COMMAND      htoi("0102")
#define HELP_CONTENTS     htoi("0003")
#define HELP_CONTEXT      htoi("0001")
#define HELP_CONTEXTPOPUP htoi("0008")
#define HELP_FORCEFILE    htoi("0009")
#define HELP_HELPONHELP   htoi("0004")
#define HELP_INDEX        htoi("0003")
#define HELP_KEY          htoi("0101")
#define HELP_MULTIKEY     htoi("0201")
#define HELP_PARTIALKEY   htoi("0105")
#define HELP_QUIT         htoi("0002")
#define HELP_SETCONTENTS  htoi("0005")
#define HELP_SETINDEX     htoi("0005")
#define HELP_SETWINPOS    htoi("0203")

****************************** End of Winapi.h ******************************
